<template>
  <div
    class="main-content-wrap d-flex align-items-center flex-column main-wrapper secondsidenav-closed bg-white"
    :class="{'sidenav-open':isSidebarOpen}"
  >
    <lenna-modal ref="lennaModal"></lenna-modal>
    <b-modal
      id="modal1"
      hide-footer
      hide-header
      centered
      ref="channelModal"
      class="border-0"
      size="600"
    >
      <router-view></router-view>
    </b-modal>
    <div class="container-fluid pt-3">
      <div class="row my-4 justify-content-around">
        <div class="col-12 col-sm-3 bg-lighter">
          <div class="card p-2">
            <img class="card-img-top card-image mx-auto" :src="asset('images/channels/mobile.png')">
            <div class="card-body text-muted">
              <h5>Your Own Apps</h5>
              <p>
                Messaging Channel
                <span class="badge badge-success" v-show="status.mobile">Connected</span>
              </p>

              <router-link v-if="status.mobile" :to="{name:'integration.mobile'}">
                <button @click="showModal" class="btn btn-outline-success">Edit Connection</button>
              </router-link>

              <router-link v-else :to="{name:'integration.mobile'}">
                <button @click="showModal" class="btn btn-outline-success">Connect</button>
              </router-link>

              <button
                v-show="status.mobile"
                @click="disconnect('mobile')"
                class="btn btn-outline-danger"
              >Disconnect</button>
            </div>
          </div>
        </div>
        <div class="col-12 col-sm-3 bg-lighter">
          <div class="card p-2">
            <img class="card-img-top card-image mx-auto" :src="asset('images/channels/line.png')">
            <div class="card-body text-muted">
              <h5>Line Messenger</h5>
              <p>
                Messaging Channel
                <span class="badge badge-success" v-show="status.line">Connected</span>
              </p>

              <router-link v-if="status.line" :to="{name:'integration.line'}">
                <button @click="showModal" class="btn btn-outline-success">Edit Connection</button>
              </router-link>

              <router-link v-else :to="{name:'integration.line'}">
                <button @click="showModal" class="btn btn-outline-success">Connect</button>
              </router-link>

              <button
                v-show="status.line"
                @click="disconnect('line')"
                class="btn btn-outline-danger"
              >Disconnect</button>
            </div>
          </div>
        </div>
        <div class="col-12 col-sm-3 bg-lighter">
          <div class="card p-2">
            <img
              class="card-img-top card-image mx-auto"
              :src="asset('images/channels/whatsapp.png')"
            >
            <div class="card-body text-muted">
              <h5>Whatsapp Messenger</h5>
              <p>
                Messaging Channel
                <span
                  class="badge badge-success"
                  v-show="status.whatsapp"
                >Connected</span>
              </p>

              <router-link v-if="status.whatsapp" :to="{name:'integration.whatsapp'}">
                <button @click="showModal" class="btn btn-outline-success">Edit Connection</button>
              </router-link>

              <router-link v-else :to="{name:'integration.whatsapp'}">
                <button @click="showModal" class="btn btn-outline-success">Connect</button>
              </router-link>

              <button
                v-show="status.whatsapp"
                @click="disconnect('whatsapp')"
                class="btn btn-outline-danger"
              >Disconnect</button>
            </div>
          </div>
        </div>
      </div>

      <div class="row my-4 justify-content-around">
        <div class="col-12 col-sm-3 bg-lighter">
          <div class="card p-2">
            <img
              class="card-img-top card-image mx-auto"
              :src="asset('images/channels/facebook.png')"
            >
            <div class="card-body text-muted">
              <h5>Facebook Messenger</h5>
              <p>
                Messaging Channel
                <span
                  class="badge badge-success"
                  v-show="status.facebook"
                >Connected</span>
              </p>

              <router-link v-if="status.facebook" :to="{name:'integration.facebook'}">
                <button @click="showModal" class="btn btn-outline-success">Edit Connection</button>
              </router-link>

              <router-link v-else :to="{name:'integration.facebook'}">
                <button @click="showModal" class="btn btn-outline-success">Connect</button>
              </router-link>

              <button
                v-show="status.facebook"
                @click="disconnect('facebook')"
                class="btn btn-outline-danger"
              >Disconnect</button>
            </div>
          </div>
        </div>
        <div class="col-12 col-sm-3 bg-lighter">
          <div class="card p-2">
            <img
              class="card-img-top card-image mx-auto"
              :src="asset('images/channels/telegram.png')"
            >
            <div class="card-body text-muted">
              <h5>Telegram Messenger</h5>
              <p>
                Messaging Channel
                <span
                  class="badge badge-success"
                  v-show="status.telegram"
                >Connected</span>
              </p>

              <router-link v-if="status.telegram" :to="{name:'integration.telegram'}">
                <button @click="showModal" class="btn btn-outline-success">Edit Connection</button>
              </router-link>

              <router-link v-else :to="{name:'integration.telegram'}">
                <button @click="showModal" class="btn btn-outline-success">Connect</button>
              </router-link>

              <button
                v-show="status.telegram"
                @click="disconnect('telegram')"
                class="btn btn-outline-danger"
              >Disconnect</button>
            </div>
          </div>
        </div>
        <div class="col-12 col-sm-3 bg-lighter">
          <div class="card p-2">
            <img
              class="card-img-top card-image mx-auto"
              :src="asset('images/channels/webchat.png')"
            >
            <div class="card-body text-muted">
              <h5>Embeddable Webchat</h5>
              <p>
                Messaging Channel
                <span class="badge badge-success" v-show="status.webchat">Connected</span>
              </p>

              <router-link v-if="status.webchat" :to="{name:'integration.webchat'}">
                <button @click="showModal" class="btn btn-outline-success">Edit Connection</button>
              </router-link>

              <router-link v-else :to="{name:'integration.webchat'}">
                <button @click="showModal" class="btn btn-outline-success">Connect</button>
              </router-link>

              <button
                v-show="status.webchat"
                @click="disconnect('webchat')"
                class="btn btn-outline-danger"
              >Disconnect</button>
            </div>
          </div>
        </div>
      </div>

      <div class="row my-4 justify-content-around">
        <div class="col-12 col-sm-3 bg-lighter">
          <div class="card p-2">
            <img
              class="card-img-top card-image mx-auto"
              :src="asset('images/icons/ic_botstudio.png')"
            >
            <div class="card-body text-muted">
              <h5>Bot Integration</h5>
              <p>
                Chatbot
                <span class="badge badge-success" v-show="status.bot">Connected</span>
              </p>

              <router-link v-if="status.bot" :to="{name:'integration.botintegration'}">
                <button @click="showModal" class="btn btn-outline-success">Edit Connection</button>
              </router-link>

              <router-link v-else :to="{name:'integration.botintegration'}">
                <button @click="showModal" class="btn btn-outline-success">Connect</button>
              </router-link>

              <button
                v-show="status.bot"
                @click="disconnect('bot')"
                class="btn btn-outline-danger"
              >Disconnect</button>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import EventBus from "@/EventBus.js";

export default {
  data() {
    return {
      status: {
        line: false,
        whatsapp: false,
        telegram: false,
        webchat: false,
        facebook: false,
        bot: false,
        mobile: false
      }
    };
  },
  methods: {
    showModal() {
      this.$refs.channelModal.show();
    },
    async disconnect(channel) {
      try {
        let data = {
          status: false,
          channelName: channel
        };
        let response = await this.$axios.put(
          `api/${this.$store.getters.appId.hashed}/integrate/update`,
          data
        );
        response = response.data;

        this.status[channel] = false;
        EventBus.$emit("toggleStatus", channel);

        this.$refs.lennaModal.show("info", "Success", response.message);
      } catch (error) {
        this.status[channel] = !this.status[channel];
        this.$refs.lennaModal.show(
          "alert",
          "Sorry",
          error.response.data.message
        );
      }
    },
    async fetchData() {
      let response = await this.$axios.get(
        `api/${this.$store.getters.appId.hashed}/integrate`
      );
      response = response.data;
      for (let channel of response.data) {
        if (channel.integration == null) {
          this.status[channel.name] = false;
        } else {
          this.status[channel.name] = channel.integration.status;
        }
      }
    }
  },
  mounted() {
    this.fetchData();

    EventBus.$on("toggleStatusMain", value => {
      this.$refs.channelModal.hide();

      this.fetchData();
    });
  }
};
</script>
<style lang="scss" scoped>
.channel-img {
  width: 2.5vw;
}
.capsule {
  transition: 0.3s;
  &:hover {
    button {
      transition: 0.3s;
      background: rgb(218, 218, 218) !important;
    }
    background: rgb(218, 218, 218) !important;
  }
  border-radius: 80px !important;
}
.btn-group {
  cursor: pointer;
}

// transition
.fade-enter-active,
.fade-leave-active {
  transition: opacity 0.25s ease-out;
}

.fade-enter,
.fade-leave-to {
  opacity: 0;
}
.bg-lighter {
  background: #fdfdfd !important;
}

.card-image {
  width: 50px;
}
</style>
